diff --git a/cdist/conf/type/__zypper_repo/explorer/all_repo_ids b/cdist/conf/type/__zypper_repo/explorer/all_repo_ids
new file mode 100644
index 00000000..b37d8ac5
--- /dev/null
+++ b/cdist/conf/type/__zypper_repo/explorer/all_repo_ids
@@ -0,0 +1,24 @@
+#!/bin/sh
+#
+# 2013 Daniel Heule (hda at sfs.biz)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+#
+# Retrieve all repo id nummbers - parsed zypper output
+#
+#
+echo $(zypper lr | cut -d'|' -f 1 | grep -E '^[0-9]')
diff --git a/cdist/conf/type/__zypper_repo/explorer/enabled_repo_ids b/cdist/conf/type/__zypper_repo/explorer/enabled_repo_ids
new file mode 100644
index 00000000..a0d092b1
--- /dev/null
+++ b/cdist/conf/type/__zypper_repo/explorer/enabled_repo_ids
@@ -0,0 +1,24 @@
+#!/bin/sh
+#
+# 2013 Daniel Heule (hda at sfs.biz)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+#
+# Retrieve all repo id nummbers from enabled repos - parsed zypper output
+#
+#
+echo $(zypper lr -E | cut -d'|' -f 1 | grep -E '^[0-9]')
diff --git a/cdist/conf/type/__zypper_repo/explorer/repo_id b/cdist/conf/type/__zypper_repo/explorer/repo_id
new file mode 100644
index 00000000..83a698b7
--- /dev/null
+++ b/cdist/conf/type/__zypper_repo/explorer/repo_id
@@ -0,0 +1,29 @@
+#!/bin/sh
+#
+# 2013 Daniel Heule (hda at sfs.biz)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+#
+# Retrieve the id from the repo with the uri from parameter repo_uri - parsed zypper output
+#
+#
+if [ -f "$__object/parameter/repo_uri" ]; then
+ uri="$(cat "$__object/parameter/repo_uri")"
+else
+ uri="$__object_id"
+fi
+echo $(zypper lr -u | grep -E "\<$uri\>" | cut -d'|' -f 1 | grep -E '^[0-9]' )
diff --git a/cdist/conf/type/__zypper_repo/gencode-remote b/cdist/conf/type/__zypper_repo/gencode-remote
new file mode 100644
index 00000000..4d834c47
--- /dev/null
+++ b/cdist/conf/type/__zypper_repo/gencode-remote
@@ -0,0 +1,102 @@
+#!/bin/sh
+#
+# 2013 Daniel Heule (hda at sfs.biz)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+#
+# Manage repo services with Zypper (mostly suse)
+#
+
+# Debug
+#exec >&2
+#set -x
+
+zypper_def_opts=" -q "
+
+if [ -f "$__object/parameter/repo_desc" ]; then
+ desc="$(cat "$__object/parameter/repo_desc")"
+else
+ desc="$__object_id"
+fi
+
+if [ -f "$__object/parameter/repo_uri" ]; then
+ uri="$(cat "$__object/parameter/repo_uri")"
+else
+ uri="$__object_id"
+fi
+
+if [ -f "$__object/parameter/repo_id" ]; then
+ id="$(cat "$__object/parameter/repo_id")"
+else
+ id="$__object_id"
+fi
+
+if [ -f "$__object/parameter/state" ]; then
+ state="$(cat "$__object/parameter/state")"
+else
+ state="present"
+fi
+
+repo_id="$(cat "$__object/explorer/repo_id")"
+
+act_id=""
+if grep -q "$id" "$__object/explorer/all_repo_ids"; then
+ act_id="$id"
+elif grep -q "$repo_id" "$__object/explorer/all_repo_ids"; then
+ act_id="$repo_id"
+fi
+
+repostate="disabled"
+if grep -q "$act_id" "$__object/explorer/enabled_repo_ids"; then
+ repostate="enabled"
+fi
+
+
+case "$state" in
+ present)
+ if [ -z "$desc" ] || [ -z "$uri" ]; then
+ echo "parameter repo_desc and repo_uri for $state needed" >&2
+ exit 4
+ fi
+ if [ -z "$repo_id" ]; then
+ # Repo not present, so we need to create it
+ echo zypper $zypper_def_opts addrepo "'$uri'" "'$desc'"
+ fi
+ ;;
+ absent)
+ if [ ! -z "$act_id" ]; then
+ # Repo present (act_id not ""), so we ned to delete it
+ echo zypper $zypper_def_opts removerepo "$act_id"
+ fi
+ ;;
+ enabled)
+ if [ ! -z "$act_id" ] && [ "$repostate" = "disabled" ]; then
+ # Repo present (act_id not "") and repostate not enabled, so a enable call is needed
+ echo zypper $zypper_def_opts modifyrepo -e "$act_id"
+ fi
+ ;;
+ disabled)
+ if [ ! -z "$act_id" ] && [ "$repostate" = "enabled" ]; then
+ # Repo present (act_id not "") and repostate enabled, so a disable call is needed
+ echo zypper $zypper_def_opts modifyrepo -d "$act_id"
+ fi
+ ;;
+ *)
+ echo "Unknown state: $state" >&2
+ exit 1
+ ;;
+esac
diff --git a/cdist/conf/type/__zypper_repo/man.text b/cdist/conf/type/__zypper_repo/man.text
new file mode 100644
index 00000000..6ea88f16
--- /dev/null
+++ b/cdist/conf/type/__zypper_repo/man.text
@@ -0,0 +1,73 @@
+cdist-type__zypper_repo(7)
+==========================
+Daniel Heule
+
+
+NAME
+----
+cdist-type__zypper_repo - repository management with zypper
+
+
+DESCRIPTION
+-----------
+zypper is usually used on the SuSE distribution to manage repositories.
+
+
+REQUIRED PARAMETERS
+-------------------
+None
+
+
+OPTIONAL PARAMETERS
+-------------------
+state::
+ Either "present" or "absent" or "enabled" or "disabled", defaults to "present" +
+ #present# - make sure that the repo is aviable, needs repo_uri and repo_desc +
+ for all following states, the repo can be searched via repo_id or repo_uri +
+ #absent# - drop the repo if found +
+ #enabled# - a repo can have state disabled if installed via zypper service (ris), in this case, you can enable the repo +
+ #disabled# - instead of absent (drop), a repo can also set to disabled, wich makes it inaccessible +
+
+repo_uri::
+ If supplied, use the uri and not the object id as repo uri.
+
+repo_desc::
+ If supplied, use the description and not the object id as repo description, only used if the state is present and the repo has to be created
+
+repo_id::
+ If supplied, use the id and not the object id as repo id, can be used with state absent, enabled and disabled
+
+
+EXAMPLES
+--------
+
+--------------------------------------------------------------------------------
+# Ensure testrepo in installed
+__zypper_repo testrepo --state present --repo_uri http://url.to.your.repo/with/path
+
+# Drop repo by repo uri
+__zypper_repo testrepo --state absent --repo_uri http://url.to.your.repo/with/path
+
+# Drop repo by id number (attention: repos are always numbered from 1 to max)
+__zypper_repo testrepo --state absent --repo_id 1
+
+# enable repo by id
+__zypper_repo testrepo2 --state enabled --repo_id 2
+
+# enable repo by uri
+__zypper_repo testrepo3 --state enabled --repo_uri http://url.to.your.repo/with/path
+
+# disable a repo works like enabling it
+__zypper_repo testrepo4 --state disabled --repo_id 4
+--------------------------------------------------------------------------------
+
+
+SEE ALSO
+--------
+- cdist-type(7)
+
+
+COPYING
+-------
+Copyright \(C) 2013 Daniel Heule. Free use of this software is
+granted under the terms of the GNU General Public License version 3 (GPLv3).
diff --git a/cdist/conf/type/__zypper_repo/parameter/default/state b/cdist/conf/type/__zypper_repo/parameter/default/state
new file mode 100644
index 00000000..e7f6134f
--- /dev/null
+++ b/cdist/conf/type/__zypper_repo/parameter/default/state
@@ -0,0 +1 @@
+present
diff --git a/cdist/conf/type/__zypper_repo/parameter/optional b/cdist/conf/type/__zypper_repo/parameter/optional
new file mode 100644
index 00000000..6f5a8325
--- /dev/null
+++ b/cdist/conf/type/__zypper_repo/parameter/optional
@@ -0,0 +1,4 @@
+state
+repo_uri
+repo_desc
+repo_id